SystemOrganization addCategory: #'Kinect-Core'!

Object subclass: #KinectServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kinect-Core'!

!KinectServer class methodsFor: 'accessing' stamp: 'Richo 9/11/2012 13:24'!
serverTypes
	^ (self subclasses collect: [:each | each codeName -> each])
		as: Dictionary! !

!KinectServer methodsFor: 'events' stamp: 'Richo 9/5/2012 17:02'!
calibrationStart: user
	self triggerEvent: #calibrationStart with: user! !

!KinectServer methodsFor: 'starting' stamp: 'Richo 9/5/2012 17:46'!
isStarted
	self subclassResponsibility! !

!KinectServer methodsFor: 'events' stamp: 'Richo 9/10/2012 15:49'!
jointUpdate: jointName position: position state: trackingState user: userId
	self triggerEvent: #jointUpdate withArguments: {jointName. position. trackingState. userId}! !

!KinectServer methodsFor: 'events' stamp: 'Richo 9/5/2012 17:01'!
lostUser: user
	self triggerEvent: #lostUser with: user! !

!KinectServer methodsFor: 'events' stamp: 'Richo 9/5/2012 17:02'!
newSkeleton: user
	self triggerEvent: #newSkeleton with: user! !

!KinectServer methodsFor: 'events' stamp: 'Richo 9/5/2012 17:00'!
newUser: user
	self triggerEvent: #newUser with: user! !

!KinectServer methodsFor: 'events' stamp: 'Richo 9/5/2012 17:01'!
poseDetected: user
	self triggerEvent: #poseDetected with: user! !

!KinectServer methodsFor: 'starting' stamp: 'Richo 9/5/2012 16:50'!
start
	self subclassResponsibility! !

!KinectServer methodsFor: 'starting' stamp: 'Richo 9/5/2012 16:50'!
stop
	self subclassResponsibility ! !

!Point methodsFor: '*kinect-core' stamp: 'Richo 1/14/2011 13:48'!
@ aNumber
	^ Point3D x: x y: y z: aNumber! !

Point subclass: #Point3D
	instanceVariableNames: 'z'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kinect-Core'!

!Point3D class methodsFor: 'instance creation' stamp: 'Richo 1/14/2011 13:50'!
x: x y: y z: z
	^ self basicNew setX: x setY: y setZ: z! !

!Point3D methodsFor: 'comparing' stamp: 'Richo 1/14/2011 14:08'!
= aPoint3D
	(aPoint3D isKindOf: self class)
		ifTrue: [^x = aPoint3D x and: [y = aPoint3D y and: [z = aPoint3D z]]]
		ifFalse: [^false]! !

!Point3D methodsFor: 'comparing' stamp: 'Richo 1/14/2011 14:09'!
hash
	"Hash is reimplemented because = is implemented."
	^ (x hash hashMultiply bitXor: y hash) hashMultiply bitXor: z hash! !

!Point3D methodsFor: 'printing' stamp: 'Richo 1/17/2011 16:51'!
printOn: aStream
super printOn: aStream.
aStream nextPut: $@.
z negative ifTrue: [
		"Avoid ambiguous @- construct"
		aStream space].
z printOn: aStream.
! !

!Point3D methodsFor: 'private' stamp: 'Richo 1/14/2011 13:50'!
setX: aNumber setY: aNumber2 setZ: aNumber3 
	x := aNumber.
	y := aNumber2.
	z := aNumber3! !

!Point3D methodsFor: 'accessing' stamp: 'Richo 1/14/2011 13:53'!
x
^x! !

!Point3D methodsFor: 'accessing' stamp: 'Richo 1/14/2011 13:53'!
y
^y! !

!Point3D methodsFor: 'accessing' stamp: 'Richo 1/14/2011 13:53'!
z
^z! !
